#include <stdio.h>
#include <stdlib.h>

#define  MACHINE_MAIN
#include "cmmd.h"

int *set_task_list(int start_task_id, int end_task_id, int step,
                   int number_of_tasks)
{
   int *tasks_list;
   int  id;
   int  i;

   if ((tasks_list = (int *) malloc(number_of_tasks * sizeof(int))) == NULL)
   {
      printf("set_task_list(): Out of memory!\n");
      exit(1);
   }

   for (i = number_of_tasks - 1, id = end_task_id; i >= 0; i--, id -= step)
      tasks_list[i] = id;

#ifdef DEBUG_set_task_list
   printf("start id = %d, end id = %d, number_of_tasks = %d\n",
          id + step , end_task_id, number_of_tasks);
#endif

   return(tasks_list);
}

main(int argc, char *argv[])
{
   int key;
   int mask;

   MPI_Init(&argc, &argv);
   MPI_Comm_size(MPI_COMM_WORLD, &(machine_info.global.number_of_tasks));
   MPI_Comm_rank(MPI_COMM_WORLD, &(machine_info.my_address));
   MPI_Comm_group(MPI_COMM_WORLD, &(machine_info.global.group));
   machine_info.global.group_comm = MPI_COMM_WORLD;

   machine_info.global.tasks_list
      = set_task_list(0, machine_info.global.number_of_tasks - 1, 1,
                      machine_info.global.number_of_tasks);

   Host = machine_info.global.number_of_tasks - 1;

   machine_info.node.number_of_tasks = machine_info.global.number_of_tasks - 1;
   machine_info.node.tasks_list
      = set_task_list(0, machine_info.global.number_of_tasks - 2, 1,
                      machine_info.node.number_of_tasks);

   MPI_Group_incl(machine_info.global.group, machine_info.node.number_of_tasks,
                  machine_info.node.tasks_list, &(machine_info.node.group));
   MPI_Comm_create(MPI_COMM_WORLD, machine_info.node.group,
                   &(machine_info.node.group_comm));

   MPE_Init_log();
   if (machine_info.my_address == 0)
   {
      MPE_Describe_state(1, 2, "Send msg", "blue:vlines3");
      MPE_Describe_state(3, 4, "Receive msg", "red:gray3");
      MPE_Describe_state(5, 6, "Barrier", "green:light_gray");
      MPE_Describe_state(7, 8, "Async. Send msg", "AliceBlue");
      MPE_Describe_state(9, 10, "Async. Receive msg", "LightBlue");
      MPE_Describe_state(11, 12, "Async. wait", "IndianRed");
   }
   MPE_Start_log();
   if (machine_info.my_address == Host)
      host_main(argc, argv);
   else
      node_main(argc, argv);

   MPE_Stop_log();
   MPE_Finish_log("lu.log");

   MPI_Finalize();
   exit(0);
}

